package ru.octol1ttle.scamstopper

import dev.kord.common.entity.Snowflake
import dev.kord.core.Kord
import dev.kord.core.event.interaction.GuildChatInputCommandInteractionCreateEvent
import dev.kord.core.event.message.MessageCreateEvent
import dev.kord.core.on
import dev.kord.gateway.Intent
import dev.kord.gateway.PrivilegedIntent
import kotlinx.coroutines.Dispatchers
import kotlinx.coroutines.withContext
import kotlinx.serialization.encodeToString
import kotlinx.serialization.json.Json
import java.io.File

val file = File("configs.json")
var configs: HashMap<Snowflake, Configuration>? = null

suspend fun main() {
    val token: String = System.getenv("BOT_TOKEN") ?: throw RuntimeException(
            "No bot token has been provided. Set the BOT_TOKEN environment variable to a valid token."
        )
    val kord = Kord(token)

    if (!file.exists()) {
        withContext(Dispatchers.IO) {
            file.createNewFile()
            file.writeText("{}")
        }
    }
    configs = Json.decodeFromString(file.readText()) ?: HashMap()

    val setLogChannelCommand = SetLogChannelCommand()
    setLogChannelCommand.register(kord)
    kord.on<GuildChatInputCommandInteractionCreateEvent> {
        setLogChannelCommand.execute(interaction)
    }

    val messageCreateListener = MessageCreateListener()
    kord.on<MessageCreateEvent> {
        messageCreateListener.execute(this)
    }

    kord.login {
        @OptIn(PrivilegedIntent::class)
        intents += Intent.MessageContent
    }
}

fun saveConfigs() {
    file.writeText(Json.encodeToString(configs))
}
