package ru.octol1ttle.scamstopper

import dev.kord.core.Kord
import dev.kord.core.behavior.interaction.respondEphemeral
import dev.kord.core.entity.interaction.GuildChatInputCommandInteraction
import dev.kord.rest.builder.interaction.channel

class SetLogChannelCommand {
    suspend fun register(kord: Kord) {
        kord.createGlobalChatInputCommand(
            "set-log-channel",
            "Sets the channel that will receive logs for scam message matches",
        ) {
            channel("log-channel", "The log channel") {
                required = true
            }
        }
    }

    suspend fun execute(interaction: GuildChatInputCommandInteraction) {
        configs!![interaction.guildId] = Configuration(interaction.command.channels["log-channel"]!!.id)
        saveConfigs()

        interaction.respondEphemeral {
            this.content = "Successfully updated log channel"
        }
    }
}